## buffybox 3.2.0+dfsg

=== lvgl/docs/requirements.txt ===
Sphinx
breathe
imagesize
importlib-metadata
sphinx-rtd-theme
sphinx-sitemap
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
sphinxcontrib-mermaid
sphinx-design
sphinx-rtd-dark-mode
typing-extensions
