=== debian/changelog ===
buffybox (3.2.0+dfsg-1) unstable; urgency=medium

  * Initial Release (Closes: #1083296)

 -- Jarrah Gosbell <debian@undef.tools>  Fri, 04 Oct 2024 09:43:29 +0000
