=== debian/control ===
Source: buffybox
Section: utils
Priority: optional
Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
Uploaders: Jarrah Gosbell <debian@undef.tools>
Build-Depends: debhelper-compat (= 13),
    libdrm-dev,
    libinih-dev,
    libinput-dev,
    libudev-dev,
    libxkbcommon-dev,
    meson,
    po-debconf,
    scdoc,
Standards-Version: 4.7.0
Homepage: https://gitlab.com/postmarketOS/buffybox
Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/buffybox
Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/buffybox.git
Rules-Requires-Root: no

Package: unl0kr
Architecture: any
Depends: ${misc:Depends},
    ${shlibs:Depends},
    cryptsetup-initramfs,
Breaks: osk-sdl (<<0.67.1-4)
Replaces: osk-sdl (<<0.67.1-4)
Provides: osk-sdl
Description: Lightweight framebuffer On-Screen-Keyboard based on LVGL
 This keyboard is designed to unlock encrypted root partitions on boot
 on mobile devices. It is automatically launched on boot, allowing the
 user to enter their disk encryption password.

Package: buffyboard
Architecture: any
Depends: ${misc:Depends},
    ${shlibs:Depends},
Description: Touch-enabled framebuffer keyboard (not only) for vampire slayers
 Buffyboard is a touch-enabled on-screen keyboard running on the Linux
 framebuffer. It's primarily intended for vampire hunting but you can also
 use it as a general purpose keyboard.
 .
 Buffyboard uses LVGL for input processing and rendering. Key events are
 forwarded directly to the kernel via a uinput device. Since the latter
 emulates a hardware keyboard, the terminal keymap must match with buffyboard's
 layout or else on-screen keys might not produce the correct result.
