=== debian/watch ===
version=4
opts=dversionmangle=auto,searchmode=plain,repacksuffix=+dfsg,repack,compression=xz \
https://gitlab.com/api/v4/projects/52322952/releases \
https://gitlab.com/-/project/52322952/uploads/[0-9a-z]*/@PACKAGE@-@ANY_VERSION@.tar.gz
