=== lvgl/docs/requirements.txt ===
Sphinx
breathe
imagesize
importlib-metadata
sphinx-sitemap
sphinxcontrib-applehelp
sphinxcontrib-devhelp
sphinxcontrib-htmlhelp
sphinxcontrib-jsmath
sphinxcontrib-qthelp
sphinxcontrib-serializinghtml
sphinxcontrib-mermaid==0.9.2
sphinx-copybutton
sphinx-design
typing-extensions
sphinx-reredirects
dirsync
furo
accessible-pygments
