=== lvgl/tests/CMakeLists.txt ===
--- 
+++ 
@@ -57,9 +57,20 @@
 
 set(LVGL_TEST_DIR ${CMAKE_CURRENT_SOURCE_DIR})
 
+set(SANITIZE_AND_COVERAGE_OPTIONS
+    -fsanitize=address
+    -fsanitize=leak
+    -fsanitize=undefined
+    --coverage
+)
 
 set(LVGL_TEST_OPTIONS_VG_LITE
     -DLV_TEST_OPTION=6
+    -Wno-dangling-pointer # workaround for thorvg dangling-pointer warning
+)
+
+set(LVGL_TEST_OPTIONS_SDL
+    -DLV_TEST_OPTION=7
 )
 
 set(LVGL_TEST_OPTIONS_MINIMAL_MONOCHROME
@@ -86,20 +97,19 @@
     -DLV_TEST_OPTION=5
     -DLVGL_CI_USING_SYS_HEAP
     -Wno-unused-but-set-variable # unused variables are common in the dual-heap arrangement
+    ${SANITIZE_AND_COVERAGE_OPTIONS}
 )
 
 set(LVGL_TEST_OPTIONS_TEST_DEFHEAP
     -DLV_TEST_OPTION=5
     -DLV_USE_OBJ_PROPERTY=1      # add obj property test and disable pedantic
+    -DLV_USE_OBJ_PROPERTY_NAME=1
     -DLVGL_CI_USING_DEF_HEAP
-    -fsanitize=address
-    -fsanitize=leak
-    -fsanitize=undefined
-    --coverage
-)
-
-if (OPTIONS_VG_LITE)
-    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_VG_LITE})
+    ${SANITIZE_AND_COVERAGE_OPTIONS}
+)
+
+if (OPTIONS_SDL)
+    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_SDL})
 elseif (OPTIONS_NORMAL_8BIT)
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_NORMAL_8BIT})
 elseif (OPTIONS_16BIT)
@@ -109,21 +119,36 @@
 elseif (OPTIONS_FULL_32BIT)
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_FULL_32BIT})
 elseif (OPTIONS_TEST_SYSHEAP)
-    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP} -fsanitize=address -fsanitize=leak -fsanitize=undefined --coverage)
-    filter_compiler_options (C TEST_LIBS --coverage -fsanitize=address -fsanitize=leak -fsanitize=undefined)
-    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
+    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP})
+    filter_compiler_options (C TEST_LIBS ${SANITIZE_AND_COVERAGE_OPTIONS})
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
     set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs/")
 elseif (OPTIONS_TEST_DEFHEAP)
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_DEFHEAP})
-    filter_compiler_options (C TEST_LIBS --coverage -fsanitize=address -fsanitize=leak -fsanitize=undefined)
-    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
+    filter_compiler_options (C TEST_LIBS ${SANITIZE_AND_COVERAGE_OPTIONS})
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
     set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs/")
 elseif (OPTIONS_TEST_MEMORYCHECK)
     # sanitizer is disabled because valgrind uses LD_PRELOAD and the
     # sanitizer lib needs to load first
     set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_TEST_SYSHEAP})
-    set (LV_CONF_BUILD_DISABLE_EXAMPLES ON)
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
     set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs/")
+elseif (OPTIONS_TEST_VG_LITE)
+    set (BUILD_OPTIONS ${LVGL_TEST_OPTIONS_VG_LITE} -DLVGL_CI_USING_SYS_HEAP ${SANITIZE_AND_COVERAGE_OPTIONS})
+    filter_compiler_options (C TEST_LIBS ${SANITIZE_AND_COVERAGE_OPTIONS})
+    set (CONFIG_LV_BUILD_EXAMPLES OFF CACHE BOOL "disable examples" FORCE)
+    set (ENABLE_TESTS ON)
+    add_definitions(-DREF_IMGS_PATH="ref_imgs_vg_lite/")
+
+    # In 32-bit systems, the output of ThorVG's anti-aliasing algorithm has a slight deviation.
+    if ($ENV{NON_AMD64_BUILD})
+        # Set a tolerance value for the VG-Lite tests.
+        add_definitions(-DREF_IMG_TOLERANCE=9)
+    endif()
 else()
     message(FATAL_ERROR "Must provide a known options value (check main.py?).")
 endif()
@@ -145,8 +170,6 @@
 
 # Options lvgl and examples are compiled with.
 set(COMPILE_OPTIONS
-    -DLV_CONF_PATH=${LVGL_TEST_DIR}/src/lv_test_conf.h
-    -DLV_BUILD_TEST
     ${BUILD_OPTIONS}
     ${BUILD_TARGET_DEF}
 )
@@ -180,8 +203,10 @@
         -Werror=float-conversion
         -Werror=strict-aliasing
         -Wno-double-promotion
-        -Wno-unused-but-set-parameter
         -Wno-unreachable-code
+        -Wno-gnu-zero-variadic-macro-arguments
+        -Wunused-function
+	-Wno-overlength-strings
     )
 else()
     list(APPEND COMPILE_OPTIONS
@@ -229,30 +254,48 @@
 get_filename_component(LVGL_DIR ${LVGL_TEST_DIR} DIRECTORY)
 
 # Include lvgl project file.
+# Set LV_BUILD_CONF_PATH so os_desktop.cmake knows about it before compiling lvgl
+# Used to preprocess lv_conf_internal.h with the test config
+set(LV_BUILD_CONF_PATH "${LVGL_TEST_DIR}/src/lv_test_conf.h" CACHE STRING "set test configuration")
+
 include(${LVGL_DIR}/CMakeLists.txt)
 target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:C>: ${LVGL_C_COMPILE_OPTIONS}>)
+target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+target_compile_definitions(lvgl PUBLIC LV_BUILD_TEST)
 if(NOT (CMAKE_C_COMPILER_ID STREQUAL "MSVC"))
-    target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:ASM>: ${LVGL_C_COMPILE_OPTIONS}>)
-endif()
-target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:CXX>: ${LVGL_CXX_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl PUBLIC $<$<COMPILE_LANGUAGE:ASM>:${LVGL_C_COMPILE_OPTIONS}>)
+endif()
+
+if (TARGET lvgl_thorvg)
+    target_compile_options(lvgl_thorvg PUBLIC $<$<COMPILE_LANGUAGE:C>:${LVGL_C_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl_thorvg PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+endif()
+
 if (TARGET lvgl_examples)
-  target_compile_options(lvgl_examples PUBLIC ${LVGL_C_COMPILE_OPTIONS})
-endif()
-
+    target_compile_options(lvgl_examples PUBLIC $<$<COMPILE_LANGUAGE:C>:${LVGL_C_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl_examples PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+endif()
+
+if (TARGET lvgl_demos)
+    target_compile_options(lvgl_demos PUBLIC $<$<COMPILE_LANGUAGE:C>:${LVGL_C_COMPILE_OPTIONS}>)
+    target_compile_options(lvgl_demos PUBLIC $<$<COMPILE_LANGUAGE:CXX>:${LVGL_CXX_COMPILE_OPTIONS}>)
+endif()
+
+
+# LVGL_CONF_DIR and LVGL_CONF_PATH are normalized and set by os_desktop.cmake
 
 set(TEST_INCLUDE_DIRS
     $<BUILD_INTERFACE:${LVGL_TEST_DIR}/src>
     $<BUILD_INTERFACE:${LVGL_TEST_DIR}/unity>
     $<BUILD_INTERFACE:${LVGL_TEST_DIR}>
+    $<BUILD_INTERFACE:${LVGL_CONF_DIR}>
 )
 
 file(GLOB_RECURSE TEST_IMAGES_SRC ${LVGL_TEST_DIR}/test_images/*.c)
 
 add_library(test_common
     STATIC
-        src/lv_test_indev.c
         src/lv_test_init.c
-        src/lv_test_helpers.c
         src/test_assets/test_animimg001.c
         src/test_assets/test_animimg002.c
         src/test_assets/test_animimg003.c
@@ -262,13 +305,15 @@
         src/test_assets/test_img_cogwheel_rgb565a8.c
         src/test_assets/test_img_cogwheel_xrgb8888.c
         src/test_assets/test_img_cogwheel_argb8888.c
+        src/test_assets/test_img_svg.c
         src/test_assets/test_font_1.c
         src/test_assets/test_font_2.c
         src/test_assets/test_font_3.c
         src/test_assets/test_font_montserrat_ascii_1bpp.c
         src/test_assets/test_font_montserrat_ascii_2bpp.c
         src/test_assets/test_font_montserrat_ascii_4bpp.c
-        src/test_assets/test_font_montserrat_ascii_4bpp_compressed.c
+        src/test_assets/test_font_montserrat_ascii_8bpp.c
+        src/test_assets/test_font_montserrat_ascii_3bpp_compressed.c
         src/test_assets/test_font_1_bin.c
         src/test_assets/test_font_2_bin.c
         src/test_assets/test_font_3_bin.c
@@ -284,12 +329,12 @@
         src/test_assets/test_imagebutton_right.c
         src/test_assets/test_music_button_play.c
         src/test_assets/test_lottie_approve.c
-        unity/unity_support.c
         unity/unity.c
         ${TEST_IMAGES_SRC}
 )
 target_include_directories(test_common PUBLIC ${TEST_INCLUDE_DIRS})
 target_compile_options(test_common PUBLIC ${LVGL_TESTFILE_COMPILE_OPTIONS})
+target_compile_definitions(test_common PRIVATE LV_BUILD_TEST ${LVGL_COMPILER_DEFINES})
 
 # Generate one test executable for each source file pair.
 # The sources in ${CMAKE_CURRENT_BINARY_DIR} is auto-generated, the
@@ -303,79 +348,9 @@
     # libjpeg is required for the jpeg test case
     find_package(JPEG REQUIRED)
     include_directories(${JPEG_INCLUDE_DIR})
-endif()
-
-# libpng is required for the png test case
-find_package(PNG REQUIRED)
-include_directories(${PNG_INCLUDE_DIR})
-
-# libfreetype is required for the font test case
-find_package(Freetype REQUIRED)
-include_directories(${FREETYPE_INCLUDE_DIRS})
-
-# libinput is required for the libinput device driver test case
-find_package(Libinput OPTIONAL_COMPONENTS)
-if ($ENV{NON_AMD64_BUILD})
-    include_directories(${LIBINPUT_INCLUDE_DIRS})
-endif()
-
-if (NOT LIBINPUT_FOUND)
-    message("libinput not found, defaulting to 0")
-    add_definitions(-DLV_USE_LIBINPUT=0)
-endif()
-
-find_package(PkgConfig)
-pkg_check_modules(xkbcommon pkg_check_modules xkbcommon)
-
-if (NOT xkbcommon_FOUND)
-    message("xkbcommon not found, defaulting to 0")
-    add_definitions(-DLV_LIBINPUT_XKB=0)
-endif()
-
-# libdrm is required for the DRM display driver test case
-include(${CMAKE_CURRENT_LIST_DIR}/FindLibDRM.cmake)
-if(Libdrm_FOUND)
-    include_directories(${Libdrm_INCLUDE_DIRS})
-else()
-    message("libdrm not found, defaulting to 0")
-    add_definitions(-DLV_USE_LINUX_DRM=0)
-endif()
-
-# If we are running on mac, set LV_USE_LINUX_FBDEV to 0
-if(APPLE)
-    add_definitions(-DLV_USE_LINUX_FBDEV=0)
-endif()
-
-if(WIN32)
-    add_definitions(-DLV_USE_LINUX_FBDEV=0)
-    add_definitions(-DLV_USE_WINDOWS=1)
-endif()
-
-# disable test targets for build only tests
-if (ENABLE_TESTS)
-    file(GLOB_RECURSE TEST_CASE_FILES src/test_cases/*.c)
-    file(GLOB_RECURSE TEST_LIBS_FILES src/test_libs/*.c)
-else()
-    set(TEST_CASE_FILES)
-    set(TEST_LIBS_FILES)
-endif()
-
-# build a test libs target
-if (TEST_LIBS_FILES)
-    add_library(test_libs STATIC ${TEST_LIBS_FILES})
-    target_include_directories(test_libs PUBLIC ${TEST_INCLUDE_DIRS} "src/test_libs")
-    target_compile_options(test_libs PUBLIC ${LVGL_TESTFILE_COMPILE_OPTIONS})
-    list(APPEND TEST_LIBS test_libs)
-endif()
-
-foreach( test_case_fname ${TEST_CASE_FILES} )
-    # If test file is foo/bar/baz.c then test_name is "baz".
-    get_filename_component(test_name ${test_case_fname} NAME_WLE)
-    if (${test_name} STREQUAL "_test_template")
-        continue()
-    endif()
-
-    # gather all test cases
-    list(APPEND TEST_CASES ${test_name})
-
-    # Create path to auto-generated source file.
+
+    # Wayland
+    find_package(PkgConfig)
+    pkg_check_modules(wayland_client wayland-client)
+
+    if (wayland_client_FOUND)
