=== debian/changelog ===
buffybox (3.4.2+dfsg-1) unstable; urgency=medium

  [ Jarrah Gosbell ]
  * d/copyright: Add upstream contact
  * d/rules: Don't replace dh clean to ensure package can build twice
  * d/control: Bump standards version (no changes required)
  * d/copyright: Fix missed flies/entries from package review
  * d/po: Unfuzzy untranslatable string in translations
  * d/copyright: Last couple of copyright fixes from review
  * d/initramfs: Add kernel modules required for PinePhone Pro
  * d/control: Add missing dependency "po-debconf"
  * New upstream version 3.4.2+dfsg
  * Update watch/copyright for v3.4.2 and new repository (Closes: #1115888)
  * d/copyright: Update for 3.4.2
  * d/patches: Remove patches fixed upstream
  * d/initramfs: Update keyscript for new no newline option
  * d/readme: Include comment about F0rmz not being included
  * d/not-installed: Do not install f0rmz
  * d/watch: Migrate to v5
  * d/source/lintian-overrides: Override examples and watch
  * d/control: Update standards version

  [ Yifei Zhan ]
  * update to the new upstream URL

  [ Andrea Bolognani ]
  * d/initramfs: Ensure target directories exist
  * d/initramfs: Copy xkb-data correctly (Closes: #1124611)
  * d/README.Debian: Fix typo
  * d/README.Debian: Explain how to set up unl0kr after installation
  * d/copyright: Update upstream URLs

  [ Carles Pina i Estany ]
  * Added po-debconf Catalan translation (Closes: #1109188)

  [ Martin Bagge ]
  * d/po: Add Sweedish translation (Closes: #1068857)

  [ Yangfl ]
  * d/po: Add Chinese translations (Closes: #1124967)

 -- Jarrah Gosbell <debian@undef.tools>  Tue, 06 Jan 2026 07:21:05 +0000
