=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: buffybox
 Section: utils
-Priority: optional
 Maintainer: DebianOnMobile Maintainers <debian-on-mobile-maintainers@alioth-lists.debian.net>
 Uploaders: Jarrah Gosbell <debian@undef.tools>
 Build-Depends: debhelper-compat (= 13),
@@ -12,11 +11,10 @@
     meson,
     po-debconf,
     scdoc,
-Standards-Version: 4.7.0
-Homepage: https://gitlab.com/postmarketOS/buffybox
+Standards-Version: 4.7.3
+Homepage: https://gitlab.postmarketos.org/postmarketOS/buffybox
 Vcs-Browser: https://salsa.debian.org/DebianOnMobile-team/buffybox
 Vcs-Git: https://salsa.debian.org/DebianOnMobile-team/buffybox.git
-Rules-Requires-Root: no
 
 Package: unl0kr
 Architecture: any
