=== debian/watch ===
Version: 5
# We can't just use the template here because we need the tarball with LVGL packed as well.
# Git with submodules may also work.
Source: https://gitlab.postmarketos.org/api/v4/projects/172/releases
Matching-Pattern: https://gitlab.postmarketos.org/-/project/172/uploads/[0-9a-z]*/@PACKAGE@-@ANY_VERSION@.tar.gz
Repack: yes
RepackSuffix: +dfsg
Compression: xz
Search-Mode: plain
Dversion-Mangle: auto
